<template>
  <section class="sign-up-form">
    <h2 class="text-center">Sign up</h2>
    <div
      class="submit-error alert alert-danger"
      v-if="submitError">
      An error ocurred. Please try again.
    </div>
    <form action="" method="post">
      <div class="form-group">
        <label for="inputLogin">Username</label>
        <input
          id="inputLogin"
          v-model="login"
          type="text"
          class="form-control">
      </div>
      <div class="form-group">
        <label for="inputPassword">Password</label>
        <input
          id="inputPassword"
          v-model="password"
          type="password"
          class="form-control">
      </div>
      <nuxt-link to="/" class="btn btn-outline-secondary">
        Back
      </nuxt-link>
      <button
        :class="btnClass"
        type="submit"
        @click.prevent="submit"
        :disabled="submitting">
        Register
      </button>
    </form>
  </section>
</template>

<script>

export default {
  data() {
    return {
      submitError: false,
      submitting: false,
      btnClass: ["btn", "btn-secondary", "btn-submit", "btn-touch", "float-right"],
    };
  },
  computed: {
    login: {
      get() {
        return this.$store.state.signup.login;
      },
      set(value) {
        this.$store.state.signup.login = value;
      }
    },
    password: {
      get() {
        return this.$store.state.signup.password;
      },
      set(value) {
        this.$store.state.signup.password = value;
      }
    },

  },
  methods: {
    submit() {
      this.submitting = true;
      this.btnClass = this.btnClass.concat("btn-disabled");
      const info = {
        user: {
          login: this.login,
          password: this.password,
        }
      };

      let ins = this;
      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/users',
        data: info
      })
        .then( res => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = false;

          // clear form data
          ins.$store.state.signup.login = '';
          ins.$store.state.signup.password = '';

          // redirect
          ins.$router.push('/');
        })
        .catch( err => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = true;

          console.log(err);
        });
    }
  },
  components: {
  }
}
</script>
